SystemOrganization addCategory: #'Rizel-Example'!

Object subclass: #RzExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Example'!

!RzExamples methodsFor: 'scenario' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 22:55'!
addressBookXML
	^'<addressbook>
  <person employee-number="A0000" family-name="Gates" first-name="Bob">
    <contact-info><!!--Confidential--></contact-info>
    <address city="Los Angeles" number="1239" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Manager"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7000" family-name="Brown"
    first-name="Robert" middle-initial="L.">
    <contact-info>
      <email address="robb@iro.ibm.com"/>
      <home-phone number="03-3987873"/>
    </contact-info>
    <address city="New York" number="344" state="NY" street="118 St."/>
    <job-info employee-type="Full-Time" is-manager="yes" job-description="Group Leader"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7890" family-name="DePaiva"
    first-name="Kassie" middle-initial="W.">
    <contact-info><!!-- Kassie''s agent phone: 03-987654 --></contact-info>
    <address city="Los Angeles" number="1234" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Actor"/>
    <manager employee-number="A0000"/>
    <misc-info>One of the most talented actresses on Daytime. Kassie
      plays the devious and beautiful Blair Cramer on ABC&apos;s
      &quot;One Life To Live.&quot;</misc-info>
  </person>
  <person employee-number="A7987" family-name="Smith" first-name="Joe">
    <contact-info>
      <email address="joes@iro.ibm.com"/>
      <mobile-phone number="888-7657765"/>
      <home-phone number="03-8767898"/>
      <home-phone number="03-8767871"/>
    </contact-info>
    <address city="New York" number="12789" state="NY" street="W. 15th Ave."/>
    <job-info employee-type="Part-Time" is-manager="no" job-description="Hacker"/>
    <manager employee-number="A7000"/>
  </person>
</addressbook>
'! !

!RzExamples methodsFor: 'scenario' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 22:50'!
buildPendrive
	|pendrive mp3s mp4s texts images|
	pendrive := RSPenDrive new.
	mp3s := RSDirectory new.
	mp3s add: (RSMP3File named:'MP3A' size:10).
	mp3s add: (RSMP3File named:'MP3B' size:10).
	mp3s add: (RSMP3File named:'MP3C' size:10).
	mp3s add: (RSMP3File named:'MP3D' size:10).

	mp3s add: (RSMP3File named:'MP3E' size:10).

	mp3s add: (RSMP3File named:'MP3F' size:10).
	
	mp4s := RSDirectory new.	
	mp4s add: (RSMP3File named:'MP4A' size:10).
	mp4s add: (RSMP3File named:'MP4B' size:10).
	mp4s add: (RSMP3File named:'MP4C' size:10).
	mp4s add: (RSMP3File named:'MP4D' size:10).
	mp4s add: (RSMP3File named:'MP4E' size:10).
	mp4s add: (RSMP3File named:'MP4F' size:10).
	
	texts := RSDirectory new.
	texts add: (RSTextFile named:'TextA' size:10).
	texts add: (RSTextFile named:'TextB' size:10).
	texts add: (RSTextFile named:'TextC' size:10).
	texts add: (RSTextFile named:'TextD' size:10).
	texts add: (RSTextFile named:'TextE' size:10).
	texts add: (RSTextFile named:'TextF' size:10).
	
	images := RSDirectory new.
	images add: (RSImageFile named:'ImageA').
	images add: (RSImageFile named:'ImageB').
	images add: (RSImageFile named:'ImageC').
	images add: (RSImageFile named:'ImageD').
	images add: (RSImageFile named:'ImageE').
	images add: (RSImageFile named:'ImageF').
	
	pendrive add: mp3s.
	pendrive add: mp4s.	
	pendrive add: texts.
	pendrive add: images.
	
	^ pendrive.! !

!RzExamples methodsFor: 'examples' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 22:58'!
exampleBuilder1
	"
	self new exampleBuilder1
	"
	|result builder|
	builder := RzBuilder new.
	builder define:#input named:#x with: #(0 1).
	builder define:#input named:#y with: #(0 1).
	builder define:#input named:#z with: #(0 1).
	result := builder execute:[ :x :y :z |  x asString, y asString, z asString].
	result values do:[ :comb| Transcript show: comb;cr.].
	Transcript show: ' ( 1, 0 , 1) => '; show:(result at: #(1 0 1));cr.! !

Object subclass: #RzRizelDemo
	instanceVariableNames: ''
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'Rizel-Example'!

!RzRizelDemo methodsFor: 'benchmarks' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 14:31'!
benchmark1
	"text files"
	((self buildPendrive) collect:[ :file |  file class = RSTextFile]) do:#open.! !

!RzRizelDemo methodsFor: 'benchmarks' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 14:31'!
benchmark2
	"text MP3"
	((self buildPendrive) collect:[ :file |  file class = RSMP3File]) do:#open.! !

!RzRizelDemo methodsFor: 'benchmarks' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 14:52'!
benchmark3
	"
	self new benchmark3
	"
	((self buildPendrive) collect:[ :file |  file class = RSImageFile]) do:#open.! !

!RzRizelDemo methodsFor: 'benchmarks' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 14:51'!
benchmark4
	"
	self new benchmark4
	"
	((self buildPendrive) collect:[ :file |  file class = RSMP4File]) do:#open.! !

!RzRizelDemo methodsFor: 'benchmarks' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 15:01'!
buildPendrive
	|pendrive mp3s mp4s texts images|
	pendrive := RSPenDrive new.
	mp3s := RSDirectory new.
	mp3s add: (RSMP3File named:'MP3A' size:10).
	mp3s add: (RSMP3File named:'MP3B' size:10).
	mp3s add: (RSMP3File named:'MP3C' size:10).
	mp3s add: (RSMP3File named:'MP3D' size:10).
	mp3s add: (RSMP3File named:'MP3E' size:10).
	mp3s add: (RSMP3File named:'MP3F' size:10).
	
	mp4s := RSDirectory new.	
	mp4s add: (RSMP4File named:'MP4A' size:10).
	mp4s add: (RSMP4File named:'MP4B' size:10).
	mp4s add: (RSMP4File named:'MP4C' size:10).
	mp4s add: (RSMP4File named:'MP4D' size:10).
	mp4s add: (RSMP4File named:'MP4E' size:10).
	mp4s add: (RSMP4File named:'MP4F' size:10).
	
	texts := RSDirectory new.
	texts add: (RSTextFile named:'TextA' size:10).
	texts add: (RSTextFile named:'TextB' size:10).
	texts add: (RSTextFile named:'TextC' size:10).
	texts add: (RSTextFile named:'TextD' size:10).
	texts add: (RSTextFile named:'TextE' size:10).
	texts add: (RSTextFile named:'TextF' size:10).
	
	images := RSDirectory new.
	images add: (RSImageFile named:'ImageA'  size:10).
	images add: (RSImageFile named:'ImageB'  size:10).
	images add: (RSImageFile named:'ImageC'  size:10).
	images add: (RSImageFile named:'ImageD'  size:10).
	images add: (RSImageFile named:'ImageE'  size:10).
	images add: (RSImageFile named:'ImageF'  size:10).
	
	pendrive add: mp3s.
	pendrive add: mp4s.	
	pendrive add: texts.
	pendrive add: images.
	
	^ pendrive.! !

!RzRizelDemo methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 22:34'!
executionTimeBenchmark1
	"
	self new executionTimeBenchmark1.
	"
	|versions benchmarks builder result|
	builder := RzBuilder new.
	versions := #( '1' '2' '3' '4' '5').
	"defining variables and execution context"
	builder define: #input named: #version 	  with: versions. 
	"automatic execution"
	result := builder execute: [ :version |
		Gofer new
				url:'http://ss3.gemstone.com/ss/Rizel';
				version: 'Rizel-Test-Scenario-JuanPabloSandovalAlcocer.',version;
				load.
		[  self perform: #benchmark1 ] timeToRun.].
	"visualizing results"
	RzVisualizer1D new
						values: (versions collect:[ :v | result at:(RzVector <== v)]);
						visualize.! !

!RzRizelDemo methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 23:19'!
methodExecutionTime
	"
	self new methodExecutionTime.
	"
	|versions benchmarks A B rzProfile builder|
	builder := RzBuilder new.
	builder define: #input named: #version with: #('1' '4').
	Cache ifNil:[
		Cache := builder execute: [ :version |
				Gofer new
					url:'http://ss3.gemstone.com/ss/Rizel';
					version: 'Rizel-Test-Scenario-JuanPabloSandovalAlcocer.',version;
					load.
				Smalltalk garbageCollect.
				builder profile:[ self perform: #benchmark3 ] inPackagesMatching: 'Rizel-Test-Scenario'
			].
		].
	"merge profiles"
	rzProfile := RzProfile merge: (Cache at: #('1')) with: (Cache at: #('4')).
	"display results"
	(RzVisualizerMerge on: rzProfile) visualize.! !

!RzRizelDemo methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 22:52'!
reset 
	Cache :=nil.! !

!RzRizelDemo methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 18:21'!
totalExecutionTime
	"
	self new totalExecutionTime.
	"
	|versions benchmarks builder result|
	builder := RzBuilder new.
	versions := #( '1' '2' '3' '4' '5').
	benchmarks := #( #benchmark1 #benchmark2 #benchmark3 #benchmark4). 
	"defining variables and execution context"
	builder define: #input named: #version 	  with: versions. 
	builder define: #input named: #benchmark   with: benchmarks.
	"automatic execution"
	result := builder execute: [ :version :benchmark |
		Gofer new
				url:'http://ss3.gemstone.com/ss/Rizel';
				version: 'Rizel-Test-Scenario-JuanPabloSandovalAlcocer.',version;
				load.
		[ self perform: benchmark ] timeToRun.].
	"visualizing results"
	RzVisualizer2D new
						xValues: versions;
						yValues: benchmarks;
						value: [ :version :bench |  result at: (RzVector <== version+bench)];
						padding: 150;
						visualize.! !
